<?php

namespace App\Models\Order\Card;

use App\Models\Branch\Branch;
use App\Models\User;
use App\Repos\Order\Card\CardOrderRepo;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\SoftDeletes;

class CardOrder extends Model
{
    use HasFactory;
    use SoftDeletes;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'unique_id',
        'card_state_id',
        'card_type_id',
        'region',
        'branch_id',
        'customer_name',
        'customer_surname',
        'customer_patronic_name',
        'born_at',
        'old_surname',
        'citizenship',
        'passport_serie',
        'passport_id',
        'passport_given_at',
        'passport_given_by',
        'born_place',
        'job_location',
        'passport_address',
        'real_address',
        'phone',
        'phone_additional',
        'status',
        'passport_one',
        'passport_two',
        'passport_three',
        'passport_four',
        'notes',
        'user_id',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'born_at' => 'date',
        'passport_given_at' => 'date',
    ];

    /**
     * User
     */
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }

    /**
     * Card state
     */
    public function cardState(): BelongsTo
    {
        return $this->belongsTo(CardState::class, 'card_state_id');
    }

    /**
     * Card type
     */
    public function cardType(): BelongsTo
    {
        return $this->belongsTo(CardType::class, 'card_type_id');
    }

    /**
     * Branch
     */
    public function branch(): BelongsTo
    {
        return $this->belongsTo(Branch::class, 'branch_id');
    }

    /**
     * "boot" method for model
     */
    protected static function boot()
    {
        parent::boot();

        static::creating(CardOrderRepo::creating());
        static::created(CardOrderRepo::created());
    }
}
